addHook("PreThinkFrame", function()
	for player in players.iterate()
        -- Validity check
        if not (
			A_KRCheckExistence(player)
			and player.playerstate == PST_LIVE
			and player.mo.skin == "sonic"
		)
            continue
        end
		
		if player.charability != CA_NONE
			if (player.powers[pw_super] and not player.krework.superpowers)
				player.charability = CA_THOK
			else
				player.charability = CA_DOUBLEJUMP
			end
		end
		
		local mo = player.mo
		
		mo.krework.sonic.charging = false
		
		-- Dust trail to show Sonic's double-jump isn't available
		if player.krework.jumpused
		and leveltime % 7 == 0
			local r = mo.radius/FRACUNIT
			local randx = (P_RandomKey(r+1) - r/2) * FRACUNIT
			local randy = (P_RandomKey(r+1) - r/2) * FRACUNIT
			local dust = P_SpawnMobjFromMobj(mo, randx, randy, mo.height/2, MT_SPINDUST)
		end
	end
end)

addHook("SpinSpecial", function(player)
	-- Have to exist to uncurl
	if not (
		A_KRCheckExistence(player)
		and player.playerstate == PST_LIVE
		and player.mo.skin == "sonic"
	)
		return false
	end
	
	local mo = player.mo
	
	-- Check conditions for charging dropdash
	-- Have to be off the ground to charge
	if not P_IsObjectOnGround(player.mo)
	-- Have to be in a jumping state to charge
	and (player.pflags & PF_JUMPED)
	-- Have to have control to charge
	and not A_KRCheckNoControl(player)
	-- Dropdash has to start with a button press, not a hold
	and (not (player.krework.pbuttons & BT_USE) or mo.krework.sonic.dropcharge > 0)
	-- Can't dropdash if you're Super Sonic and your ability changes are turned off
	and not (player.powers[pw_super] and not player.krework.superpowers)
		A_KRChargeDropDash(player)
	end
end)

addHook("AbilitySpecial", A_KRSonicDoubleJump)

addHook("PlayerThink", function(player)
	-- Validity check
	if not (
		A_KRCheckExistence(player)
		and player.playerstate == PST_LIVE
		and player.mo.skin == "sonic"
	)
		return
	end
	
	local mo = player.mo
	
	-- Release drop dash if you hit the ground while charged
	if mo.eflags & MFE_JUSTHITFLOOR
	and mo.krework.sonic.dropcharge > 0
	and not (mo.eflags & MFE_SPRUNG)
		A_KRReleaseDropDash(player)
	end
	
	-- If charge conditions aren't met, discharge the dropdash
	if not mo.krework.sonic.charging
		mo.krework.sonic.dropcharge = 0
		if mo.state == S_DROPDASH1
			mo.state = S_PLAY_JUMP
		end
	end
end)
