-- Change to make aircurling eat Tails's remaining fly boosts
local CURLING_EATS_FLY = false

addHook("PreThinkFrame", function(player)
	for player in players.iterate()
		-- Validity check
		if not (
			A_KRCheckExistence(player)
			and player.mo.skin == "tails"
			and not (player.bot == 1)
			and player.playerstate == PST_LIVE
		)
			continue
		end
		
		local mo = player.mo
		player.krework.jumpused = not(max(mo.krework.tails.flycount, 0))
		
		-- Have to have flight or swimming to stay in tired flying state
		if not (mo.eflags & MFE_UNDERWATER)
			-- Swimming doesn't affect air flight physics, so go with that
			player.charability = CA_SWIM
		else
			-- Having swimming does affect swimming physics, so take it away underwater
			player.charability = CA_NONE
			-- Also infinite vertboost count when swimming
			A_KRTailsResetFlyCount(player)
		end
	end
end)

addHook("AbilitySpecial", A_KRTailsFly)

addHook("PlayerThink", function(player)
	-- Validity check
	if not (
		A_KRCheckExistence(player)
		and player.mo.skin == "tails"
		and not player.bot
		and player.playerstate == PST_LIVE
	)
		return
	end
	
	local mo = player.mo
	
	-- Eat all remaining fly boosts if you've aircurled
	if mo.krework.tails.flytime > 0 and mo.krework.aircurled and CURLING_EATS_FLY
		mo.krework.tails.flycount = 0
		return
	end
	
	-- If you're flying, run flying physics
	if (mo.state == S_PLAY_FLY 
		or mo.state == S_PLAY_FLY_TIRED
		or mo.state == S_PLAY_SWIM)
		A_KRTailsHover(player)
	-- Otherwise, reset how long you've been flying
	else
		p.mo.krework.tails.flytime = 0
	end
end)